"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const jsonrequest_js_1 = __importDefault(require("../jsonrequest.js"));
const encoding_js_1 = require("../../../encoding/encoding.js");
const types_js_1 = require("./models/types.js");
class AccountAssetInformation extends jsonrequest_js_1.default {
    constructor(c, account, assetID) {
        super(c);
        this.account = account.toString();
        this.assetID = BigInt(assetID);
    }
    path() {
        return `/v2/accounts/${this.account}/assets/${this.assetID}`;
    }
    // eslint-disable-next-line class-methods-use-this
    prepare(response) {
        return (0, encoding_js_1.decodeJSON)(response.getJSONText(), types_js_1.AccountAssetResponse);
    }
}
exports.default = AccountAssetInformation;
//# sourceMappingURL=accountAssetInformation.js.map