"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const jsonrequest_js_1 = __importDefault(require("../jsonrequest.js"));
const encoding_js_1 = require("../../../encoding/encoding.js");
const statedelta_js_1 = require("../../../types/statedelta.js");
class GetLedgerStateDelta extends jsonrequest_js_1.default {
    constructor(c, round) {
        super(c);
        this.round = BigInt(round);
        this.query = { format: 'msgpack' };
    }
    // eslint-disable-next-line class-methods-use-this
    path() {
        return `/v2/deltas/${this.round}`;
    }
    // eslint-disable-next-line class-methods-use-this
    prepare(response) {
        return (0, encoding_js_1.decodeMsgpack)(response.body, statedelta_js_1.LedgerStateDelta);
    }
}
exports.default = GetLedgerStateDelta;
//# sourceMappingURL=getLedgerStateDelta.js.map