"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const jsonrequest_js_1 = __importDefault(require("../jsonrequest.js"));
const encoding_js_1 = require("../../../encoding/encoding.js");
const types_js_1 = require("./models/types.js");
/**
 * returns the transaction information for a specific txid of a pending transaction
 */
class PendingTransactionInformation extends jsonrequest_js_1.default {
    constructor(c, txid) {
        super(c);
        this.txid = txid;
        this.query.format = 'msgpack';
    }
    // eslint-disable-next-line class-methods-use-this
    prepare(response) {
        return (0, encoding_js_1.decodeMsgpack)(response.body, types_js_1.PendingTransactionResponse);
    }
    path() {
        return `/v2/transactions/pending/${this.txid}`;
    }
    // max sets the maximum number of txs to return
    max(max) {
        this.query.max = max;
        return this;
    }
}
exports.default = PendingTransactionInformation;
//# sourceMappingURL=pendingTransactionInformation.js.map