"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const jsonrequest_js_1 = __importDefault(require("../jsonrequest.js"));
const encoding_js_1 = require("../../../encoding/encoding.js");
const types_js_1 = require("./models/types.js");
/**
 * pendingTransactionsInformation returns transactions that are pending in the pool
 */
class PendingTransactions extends jsonrequest_js_1.default {
    constructor(c) {
        super(c);
        this.query.format = 'msgpack';
    }
    /* eslint-disable class-methods-use-this */
    path() {
        return '/v2/transactions/pending';
    }
    prepare(response) {
        return (0, encoding_js_1.decodeMsgpack)(response.body, types_js_1.PendingTransactionsResponse);
    }
    /* eslint-enable class-methods-use-this */
    // max sets the maximum number of txs to return
    max(max) {
        this.query.max = max;
        return this;
    }
}
exports.default = PendingTransactions;
//# sourceMappingURL=pendingTransactions.js.map