"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const jsonrequest_js_1 = __importDefault(require("../jsonrequest.js"));
const encoding_js_1 = require("../../../encoding/encoding.js");
const types_js_1 = require("./models/types.js");
/**
 * returns all transactions for a PK [addr] in the [first, last] rounds range.
 */
class PendingTransactionsByAddress extends jsonrequest_js_1.default {
    constructor(c, address) {
        super(c);
        this.address = address.toString();
        this.query.format = 'msgpack';
    }
    // eslint-disable-next-line class-methods-use-this
    prepare(response) {
        return (0, encoding_js_1.decodeMsgpack)(response.body, types_js_1.PendingTransactionsResponse);
    }
    path() {
        return `/v2/accounts/${this.address}/transactions/pending`;
    }
    // max sets the maximum number of txs to return
    max(max) {
        this.query.max = max;
        return this;
    }
}
exports.default = PendingTransactionsByAddress;
//# sourceMappingURL=pendingTransactionsByAddress.js.map