"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BooleanSchema = void 0;
const encoding_js_1 = require("../encoding.js");
/* eslint-disable class-methods-use-this */
class BooleanSchema extends encoding_js_1.Schema {
    defaultValue() {
        return false;
    }
    isDefaultValue(data) {
        return data === false;
    }
    prepareMsgpack(data) {
        if (typeof data === 'boolean') {
            return data;
        }
        throw new Error('Invalid boolean');
    }
    fromPreparedMsgpack(encoded, 
    // eslint-disable-next-line @typescript-eslint/no-unused-vars
    _rawStringProvider) {
        if (typeof encoded === 'boolean') {
            return encoded;
        }
        throw new Error('Invalid boolean');
    }
    prepareJSON(data, // eslint-disable-next-line @typescript-eslint/no-unused-vars
    _options) {
        if (typeof data === 'boolean') {
            return data;
        }
        throw new Error('Invalid boolean');
    }
    fromPreparedJSON(encoded) {
        if (typeof encoded === 'boolean') {
            return encoded;
        }
        throw new Error('Invalid boolean');
    }
}
exports.BooleanSchema = BooleanSchema;
//# sourceMappingURL=boolean.js.map