"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.StringSchema = void 0;
const encoding_js_1 = require("../encoding.js");
/* eslint-disable class-methods-use-this */
class StringSchema extends encoding_js_1.Schema {
    defaultValue() {
        return '';
    }
    isDefaultValue(data) {
        return data === '';
    }
    prepareMsgpack(data) {
        if (typeof data === 'string') {
            return data;
        }
        throw new Error(`Invalid string: (${typeof data}) ${data}`);
    }
    fromPreparedMsgpack(encoded, 
    // eslint-disable-next-line @typescript-eslint/no-unused-vars
    _rawStringProvider) {
        if (typeof encoded === 'string') {
            return encoded;
        }
        throw new Error(`Invalid string: (${typeof encoded}) ${encoded}`);
    }
    prepareJSON(data, 
    // eslint-disable-next-line @typescript-eslint/no-unused-vars
    _options) {
        if (typeof data === 'string') {
            return data;
        }
        throw new Error(`Invalid string: (${typeof data}) ${data}`);
    }
    fromPreparedJSON(encoded) {
        if (typeof encoded === 'string') {
            return encoded;
        }
        throw new Error(`Invalid string: (${typeof encoded}) ${encoded}`);
    }
}
exports.StringSchema = StringSchema;
//# sourceMappingURL=string.js.map