"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Uint64Schema = void 0;
const encoding_js_1 = require("../encoding.js");
const utils_js_1 = require("../../utils/utils.js");
/* eslint-disable class-methods-use-this */
class Uint64Schema extends encoding_js_1.Schema {
    defaultValue() {
        return BigInt(0);
    }
    isDefaultValue(data) {
        if (typeof data === 'bigint')
            return data === BigInt(0);
        if (typeof data === 'number')
            return data === 0;
        return false;
    }
    prepareMsgpack(data) {
        return (0, utils_js_1.ensureUint64)(data);
    }
    fromPreparedMsgpack(encoded, 
    // eslint-disable-next-line @typescript-eslint/no-unused-vars
    _rawStringProvider) {
        return (0, utils_js_1.ensureUint64)(encoded);
    }
    prepareJSON(data, 
    // eslint-disable-next-line @typescript-eslint/no-unused-vars
    _options) {
        return (0, utils_js_1.ensureUint64)(data);
    }
    fromPreparedJSON(encoded) {
        return (0, utils_js_1.ensureUint64)(encoded);
    }
}
exports.Uint64Schema = Uint64Schema;
//# sourceMappingURL=uint64.js.map