"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.UntypedSchema = void 0;
const encoding_js_1 = require("../encoding.js");
/* eslint-disable class-methods-use-this */
class UntypedSchema extends encoding_js_1.Schema {
    defaultValue() {
        return undefined;
    }
    isDefaultValue(data) {
        return data === undefined;
    }
    prepareMsgpack(data) {
        // Value is already MsgpackEncodingData, since it is returned as such from
        // fromPreparedMsgpack and fromPreparedJSON
        return data;
    }
    fromPreparedMsgpack(encoded, 
    // eslint-disable-next-line @typescript-eslint/no-unused-vars
    _rawStringProvider) {
        return encoded;
    }
    prepareJSON(data, 
    // eslint-disable-next-line @typescript-eslint/no-unused-vars
    _options) {
        return (0, encoding_js_1.msgpackEncodingDataToJSONEncodingData)(data);
    }
    fromPreparedJSON(encoded) {
        return (0, encoding_js_1.jsonEncodingDataToMsgpackEncodingData)(encoded);
    }
}
exports.UntypedSchema = UntypedSchema;
//# sourceMappingURL=untyped.js.map