import JSONRequest from '../jsonrequest.js';
import { decodeJSON } from '../../../encoding/encoding.js';
import { AccountAssetResponse } from './models/types.js';
export default class AccountAssetInformation extends JSONRequest {
    constructor(c, account, assetID) {
        super(c);
        this.account = account.toString();
        this.assetID = BigInt(assetID);
    }
    path() {
        return `/v2/accounts/${this.account}/assets/${this.assetID}`;
    }
    // eslint-disable-next-line class-methods-use-this
    prepare(response) {
        return decodeJSON(response.getJSONText(), AccountAssetResponse);
    }
}
//# sourceMappingURL=accountAssetInformation.js.map