import JSONRequest from '../jsonrequest.js';
import { decodeJSON } from '../../../encoding/encoding.js';
import { BlockHashResponse } from './models/types.js';
export default class GetBlockHash extends JSONRequest {
    constructor(c, roundNumber) {
        super(c);
        this.round = BigInt(roundNumber);
    }
    path() {
        return `/v2/blocks/${this.round}/hash`;
    }
    // eslint-disable-next-line class-methods-use-this
    prepare(response) {
        return decodeJSON(response.getJSONText(), BlockHashResponse);
    }
}
//# sourceMappingURL=getBlockHash.js.map