import JSONRequest from '../jsonrequest.js';
import { decodeJSON } from '../../../encoding/encoding.js';
import { BlockTxidsResponse } from './models/types.js';
export default class GetBlockTxids extends JSONRequest {
    constructor(c, roundNumber) {
        super(c);
        this.round = BigInt(roundNumber);
    }
    path() {
        return `/v2/blocks/${this.round}/txids`;
    }
    // eslint-disable-next-line class-methods-use-this
    prepare(response) {
        return decodeJSON(response.getJSONText(), BlockTxidsResponse);
    }
}
//# sourceMappingURL=getBlockTxids.js.map