import JSONRequest from '../jsonrequest.js';
import { decodeMsgpack } from '../../../encoding/encoding.js';
import { LedgerStateDelta } from '../../../types/statedelta.js';
export default class GetLedgerStateDelta extends JSONRequest {
    constructor(c, round) {
        super(c);
        this.round = BigInt(round);
        this.query = { format: 'msgpack' };
    }
    // eslint-disable-next-line class-methods-use-this
    path() {
        return `/v2/deltas/${this.round}`;
    }
    // eslint-disable-next-line class-methods-use-this
    prepare(response) {
        return decodeMsgpack(response.body, LedgerStateDelta);
    }
}
//# sourceMappingURL=getLedgerStateDelta.js.map