import JSONRequest from '../jsonrequest.js';
import { decodeMsgpack } from '../../../encoding/encoding.js';
import { LedgerStateDelta } from '../../../types/statedelta.js';
export default class GetLedgerStateDeltaForTransactionGroup extends JSONRequest {
    constructor(c, id) {
        super(c);
        this.id = id;
        this.query = { format: 'msgpack' };
    }
    // eslint-disable-next-line class-methods-use-this
    path() {
        return `/v2/deltas/txn/group/${this.id}`;
    }
    // eslint-disable-next-line class-methods-use-this
    prepare(response) {
        return decodeMsgpack(response.body, LedgerStateDelta);
    }
}
//# sourceMappingURL=getLedgerStateDeltaForTransactionGroup.js.map