import JSONRequest from '../jsonrequest.js';
import { decodeJSON } from '../../../encoding/encoding.js';
import { StateProof as SP } from './models/types.js';
export default class StateProof extends JSONRequest {
    constructor(c, round) {
        super(c);
        this.round = BigInt(round);
    }
    path() {
        return `/v2/stateproofs/${this.round}`;
    }
    // eslint-disable-next-line class-methods-use-this
    prepare(response) {
        return decodeJSON(response.getJSONText(), SP);
    }
}
//# sourceMappingURL=stateproof.js.map