import { Schema, } from '../encoding.js';
/* eslint-disable class-methods-use-this */
export class BooleanSchema extends Schema {
    defaultValue() {
        return false;
    }
    isDefaultValue(data) {
        return data === false;
    }
    prepareMsgpack(data) {
        if (typeof data === 'boolean') {
            return data;
        }
        throw new Error('Invalid boolean');
    }
    fromPreparedMsgpack(encoded, 
    // eslint-disable-next-line @typescript-eslint/no-unused-vars
    _rawStringProvider) {
        if (typeof encoded === 'boolean') {
            return encoded;
        }
        throw new Error('Invalid boolean');
    }
    prepareJSON(data, // eslint-disable-next-line @typescript-eslint/no-unused-vars
    _options) {
        if (typeof data === 'boolean') {
            return data;
        }
        throw new Error('Invalid boolean');
    }
    fromPreparedJSON(encoded) {
        if (typeof encoded === 'boolean') {
            return encoded;
        }
        throw new Error('Invalid boolean');
    }
}
//# sourceMappingURL=boolean.js.map