import { Schema, } from '../encoding.js';
import { ensureUint64 } from '../../utils/utils.js';
/* eslint-disable class-methods-use-this */
export class Uint64Schema extends Schema {
    defaultValue() {
        return BigInt(0);
    }
    isDefaultValue(data) {
        if (typeof data === 'bigint')
            return data === BigInt(0);
        if (typeof data === 'number')
            return data === 0;
        return false;
    }
    prepareMsgpack(data) {
        return ensureUint64(data);
    }
    fromPreparedMsgpack(encoded, 
    // eslint-disable-next-line @typescript-eslint/no-unused-vars
    _rawStringProvider) {
        return ensureUint64(encoded);
    }
    prepareJSON(data, 
    // eslint-disable-next-line @typescript-eslint/no-unused-vars
    _options) {
        return ensureUint64(data);
    }
    fromPreparedJSON(encoded) {
        return ensureUint64(encoded);
    }
}
//# sourceMappingURL=uint64.js.map