import JSONRequest from '../jsonrequest.js';
import { HTTPClient, HTTPClientResponse } from '../../client.js';
import { Account } from './models/types.js';
import { Address } from '../../../encoding/address.js';
export default class AccountInformation extends JSONRequest<Account> {
    private account;
    constructor(c: HTTPClient, account: string | Address);
    path(): string;
    /**
     * Exclude assets and application data from results
     *
     * #### Example
     * ```typescript
     * const address = "XBYLS2E6YI6XXL5BWCAMOA4GTWHXWENZMX5UHXMRNWWUQ7BXCY5WC5TEPA";
     * const accountInfo = await algodClient.accountInformation(address)
     *        .exclude('all')
     *        .do();
     * ```
     *
     * @param round
     * @category query
     */
    exclude(exclude: string): this;
    prepare(response: HTTPClientResponse): Account;
}
