import { HTTPClient, HTTPClientResponse } from '../../client.js';
import { CompileResponse } from './models/types.js';
import JSONRequest from '../jsonrequest.js';
/**
 * Sets the default header (if not previously set)
 * @param headers - A headers object
 */
export declare function setHeaders(headers?: Record<string, any>): Record<string, any>;
/**
 * Executes compile
 */
export default class Compile extends JSONRequest<CompileResponse> {
    private source;
    constructor(c: HTTPClient, source: string | Uint8Array);
    path(): string;
    sourcemap(map?: boolean): this;
    protected executeRequest(headers?: Record<string, string>, customOptions?: Record<string, unknown>): Promise<HTTPClientResponse>;
    prepare(response: HTTPClientResponse): CompileResponse;
}
