import { HTTPClient, HTTPClientResponse } from '../../client.js';
import { DisassembleResponse } from './models/types.js';
import JSONRequest from '../jsonrequest.js';
/**
 * Sets the default header (if not previously set)
 * @param headers - A headers object
 */
export declare function setHeaders(headers?: Record<string, any>): Record<string, any>;
/**
 * Executes disassemble
 */
export default class Disassemble extends JSONRequest<DisassembleResponse> {
    private source;
    constructor(c: HTTPClient, source: string | Uint8Array);
    path(): string;
    protected executeRequest(headers?: Record<string, string>, customOptions?: Record<string, unknown>): Promise<HTTPClientResponse>;
    prepare(response: HTTPClientResponse): DisassembleResponse;
}
