import JSONRequest from '../jsonrequest.js';
import { HTTPClient, HTTPClientResponse } from '../../client.js';
import { TransactionProofResponse } from './models/types.js';
export default class GetTransactionProof extends JSONRequest<TransactionProofResponse> {
    private txID;
    private round;
    constructor(c: HTTPClient, round: number | bigint, txID: string);
    path(): string;
    /**
     * Exclude assets and application data from results
     * The type of hash function used to create the proof, must be one of: "sha512_256", "sha256"
     *
     * #### Example
     * ```typescript
     * const hashType = "sha256";
     * const round = 123456;
     * const txId = "abc123;
     * const txProof = await algodClient.getTransactionProof(round, txId)
     *        .hashType(hashType)
     *        .do();
     * ```
     *
     * @param hashType
     * @category query
     */
    hashType(hashType: string): this;
    prepare(response: HTTPClientResponse): TransactionProofResponse;
}
