import { PostTransactionsResponse } from './models/types.js';
import { HTTPClient, HTTPClientResponse } from '../../client.js';
import JSONRequest from '../jsonrequest.js';
/**
 * Sets the default header (if not previously set) for sending a raw
 * transaction.
 * @param headers - A headers object
 */
export declare function setSendTransactionHeaders(headers?: Record<string, string>): Record<string, string>;
/**
 * broadcasts the passed signed txns to the network
 */
export default class SendRawTransaction extends JSONRequest<PostTransactionsResponse> {
    private txnBytesToPost;
    constructor(c: HTTPClient, stxOrStxs: Uint8Array | Uint8Array[]);
    path(): string;
    protected executeRequest(headers?: Record<string, string>, customOptions?: Record<string, unknown>): Promise<HTTPClientResponse>;
    prepare(response: HTTPClientResponse): PostTransactionsResponse;
}
