import { HTTPClient } from '../client.js';
import { BaseHTTPClient } from '../baseHTTPClient.js';
import { TokenHeader } from '../urlTokenBaseHTTPClient.js';
export type TokenHeaderIdentifier = 'X-Indexer-API-Token' | 'X-KMD-API-Token' | 'X-Algo-API-Token' | string;
/**
 * Abstract service client to encapsulate shared AlgodClient and IndexerClient logic
 */
export default abstract class ServiceClient {
    /** @ignore */
    c: HTTPClient;
    constructor(tokenHeaderIdentifier: TokenHeaderIdentifier, tokenHeaderOrStrOrBaseClient: string | TokenHeader | BaseHTTPClient, baseServer: string, port?: string | number, defaultHeaders?: Record<string, any>);
}
