import { Schema, MsgpackEncodingData, MsgpackRawStringProvider, JSONEncodingData, PrepareJSONOptions } from '../encoding.js';
/**
 * BlockHashSchema is a schema for block hashes.
 *
 * In msgapck, these types are encoded as 32-byte binary strings. In JSON, they
 * are encoded as strings prefixed with "blk-" followed by the base32 encoding
 * of the 32-byte block hash without any padding.
 */
export declare class BlockHashSchema extends Schema {
    defaultValue(): Uint8Array;
    isDefaultValue(data: unknown): boolean;
    prepareMsgpack(data: unknown): MsgpackEncodingData;
    fromPreparedMsgpack(encoded: MsgpackEncodingData, _rawStringProvider: MsgpackRawStringProvider): Uint8Array;
    prepareJSON(data: unknown, _options: PrepareJSONOptions): JSONEncodingData;
    fromPreparedJSON(encoded: JSONEncodingData): Uint8Array;
}
