import { Transaction } from './transaction.js';
import { LogicSig, LogicSigAccount } from './logicsig.js';
/**
 * signLogicSigTransactionObject takes a transaction and a LogicSig object and
 * returns a signed transaction.
 *
 * @param txn - The transaction to sign.
 * @param lsigObject - The LogicSig object that will sign the transaction.
 *
 * @returns Object containing txID and blob representing signed transaction.
 */
export declare function signLogicSigTransactionObject(txn: Transaction, lsigObject: LogicSig | LogicSigAccount): {
    txID: string;
    blob: Uint8Array;
};
/**
 * signLogicSigTransaction takes a transaction and a LogicSig object and returns
 * a signed transaction.
 *
 * @param txn - The transaction to sign.
 * @param lsigObject - The LogicSig object that will sign the transaction.
 *
 * @returns Object containing txID and blob representing signed transaction.
 * @throws error on failure
 */
export declare function signLogicSigTransaction(txn: Transaction, lsigObject: LogicSig | LogicSigAccount): {
    txID: string;
    blob: Uint8Array;
};
